#!/bin/awk -f
#
# Copyright (c) Pablo Virolainen 2005 
# 
# License gpl (see LICENSE.TXT for more information)
# 
# 
BEGIN{
  FS="\"";
}

function clear_state() {
  for(i=1;i<=9;i++) {
    counters[i]=0;
  }
  delete A1;delete A2;delete A3;delete A4;delete A5;delete A6;delete A7;delete A8;delete A9;
  A1[0]="";A2[0]="";A3[0]="";A4[0]="";A5[0]="";A6[0]="";A7[0]="";A8[0]="";A9[0]="";
}

function bar(array,value,ind) {
  if (value in array) {
    return array[value];
  } else {
    counters[ind]++;
    array[value]=counters[ind];
    return counters[ind];
  }
}

function parameters(str) {
  pos=index(str,"?");
  print pos;#" "str;
  if (pos==0) {
    return "";
  } else {
    return substr(str,pos);
  }
}
{
  if (PREV_FILE != FILENAME) {
    clear_state();
    if (PREV_FILE != "") {
      eof();
    }
    PREV_FILE=FILENAME;
    if (FILENAME == "-") {
      indexname = "/dev/stdout";
      dictname = "/dev/stderr";
    } else {
      indexname=FILENAME".index";
      dictname=FILENAME".dict";
    }
  }
  split($1,tmp,"[");
  split(tmp[1],tmp2," ");
  split($3,tmp3," ");
  
  #Maybe we should seperate the parameters from the command..
  #split($2,tmp4," ");
  #print"Parameters in "tmp4[2]" are \"" parameters(tmp4[2]) "\"";
  
  print ""bar(A1,tmp2[1],1)" "bar(A2,tmp2[2],2)" "bar(A3,tmp2[3],3)" "bar(A4,tmp[2],4)" "bar(A5,$2,5)" "bar(A6,tmp3[1],6)" "bar(A7,tmp3[2],7)" "bar(A8,$4,8)" "bar(A9,$6,9) > indexname;
  delete tmp;delete tmp2;delete temp3;
}

function rintti(par,size) {
  for (x in par) {
    tmp[par[x]]=x;
  }
  delete par;
  for (i=1;i<size;i=i+1) {
    printf "%s\"",tmp[i] > dictname;
  }
  printf "%s\n",tmp[size] > dictname;
  delete tmp;
}

function eof() {
  rintti(A1,counters[1]);
  rintti(A2,counters[2]);
  rintti(A3,counters[3]);
  rintti(A4,counters[4]);
  rintti(A5,counters[5]);
  rintti(A6,counters[6]);
  rintti(A7,counters[7]);
  rintti(A8,counters[8]);
  rintti(A9,counters[9]);
}

END {
  eof();
}
